import { DocumentNode } from 'graphql';
import { Cache, ApolloCache, DataProxy, Transaction } from 'apollo-cache';
import { ApolloReducerConfig, NormalizedCacheObject } from 'apollo-cache-inmemory';
export declare class ReduxCache extends ApolloCache<NormalizedCacheObject> {
    private config;
    private optimistic;
    private watches;
    private addTypename;
    private store;
    private silenceBroadcast;
    constructor(config: ApolloReducerConfig, store: any);
    restore(data: NormalizedCacheObject): this;
    extract(optimistic?: boolean): NormalizedCacheObject;
    read<T>(query: Cache.ReadOptions): T | null;
    write(write: Cache.WriteOptions): void;
    diff<T>(query: Cache.DiffOptions): Cache.DiffResult<T>;
    watch(watch: Cache.WatchOptions): () => void;
    evict(query: Cache.EvictOptions): Cache.EvictionResult;
    reset(): Promise<void>;
    removeOptimistic(id: string): void;
    performTransaction(transaction: Transaction<NormalizedCacheObject>): void;
    recordOptimisticTransaction(transaction: Transaction<NormalizedCacheObject>, id: string): void;
    readQuery<QueryType>(options: DataProxy.Query, optimistic?: boolean): QueryType;
    readFragment<FragmentType>(options: DataProxy.Fragment, optimistic?: boolean): FragmentType | null;
    writeQuery(options: DataProxy.WriteQueryOptions): void;
    writeFragment(options: DataProxy.WriteFragmentOptions): void;
    private broadcastWatches();
    private getReducer();
    transformDocument(document: DocumentNode): DocumentNode;
}
